Subject: bug#66394: 29.1; Make register-read-with-preview more useful

From: Stefan Monnier <[email-masked]>
Date: Sat, 25 Nov 2023 16:38:34 -0500

>> >   In toplevel form:
>> >   register.el:33:37: Warning: `eql' called with 1 argument, but requires 2
>> >   register.el:33:45: Warning: reference to free variable `integer'
>> I have not these warnings.
> Strange.  Maybe Stefan can explain how could that happen.

It's because of:

    (cl--generic-prefill-dispatchers 0 (eql 'x) integer)

This needs to be in `cl-generic.el` because that's where the
`cl--generic-prefill-dispatchers` macro is defined.  Thierry had it in
`register.el` which worked OK when `register.el` gets compiled with the
bootstrap Emacs where `cl-generic` has not yet been compiled but it
fails when compiled with an Emacs where `cl-generic` has been compiled
because in that case the macro is not defined so the compiler compiles
the above line as a function call, resulting in the above two warnings.

        Stefan